datablock AudioProfile(ThunderShotFireSound)
{
   filename    = "./ThunderShotShot.wav";
   description = AudioClose3d;
   preload = true;
};

//shell
//datablock DebrisData(gunShellDebris)
//{
//	shapeFile = "./gunShell.dts";
//	lifetime = 2.0;
//	minSpinSpeed = -400.0;
//	maxSpinSpeed = 200.0;
//	elasticity = 0.5;
//	friction = 0.2;
//	numBounces = 3;
//	staticOnMaxBounce = true;
//	snapOnMaxBounce = false;
//	fade = true;
//
//	gravModifier = 2;
//};


//muzzle flash effects
datablock ParticleData(ThunderShotFlashParticle)
{
	dragCoefficient			= 3;
	gravityCoefficient		= 0.8;
	inheritedVelFactor		= 0.7;
	constantAcceleration	= 0.0;
	lifetimeMS				= 160;
	lifetimeVarianceMS		= 40;
	textureName				= "add-ons/projectile_radio_wave/bolt.png";
	spinSpeed				= 10.0;
	spinRandomMin			= -500.0;
	spinRandomMax			= 500.0;
	colors[0]				= "0.9 0.9 0.0 0.8";
	colors[1]				= "0.9 0.9 0.0 0.0";
	sizes[0]				= 0.2;
	sizes[1]				= 1.0;
	
	useInvAlpha = false;
};
datablock ParticleEmitterData(ThunderShotFlashEmitter)
{
	ejectionPeriodMS	= 2;
	periodVarianceMS	= 0;
	ejectionVelocity	= 2.0;
	velocityVariance	= 1.5;
	ejectionOffset		= 0.0;
	thetaMin			= 0;
	thetaMax			= 90;
	phiReferenceVel		= 0;
	phiVariance			= 360;
	overrideAdvance		= false;
	particles			= "ThunderShotFlashParticle";
};

datablock ParticleData(ThunderShotChargedParticle)
{
	dragCoefficient			= 3;
	gravityCoefficient		= 0;
	inheritedVelFactor		= 0.7;
	constantAcceleration	= 0.0;
	lifetimeMS				= 105;
	lifetimeVarianceMS		= 35;
	textureName				= "add-ons/projectile_radio_wave/bolt.png";
	spinSpeed				= 5.0;
	spinRandomMin			= -50.0;
	spinRandomMax			= 50.0;
	colors[0]				= "0.9 0.9 0.0 0.2";
	colors[1]				= "0.9 0.9 0.0 0.0";
	sizes[0]				= 0.2;
	sizes[1]				= 0.4;
	
	useInvAlpha = false;
};
datablock ParticleEmitterData(ThunderShotChargedEmitter)
{
	ejectionPeriodMS	= 10;
	periodVarianceMS	= 5;
	ejectionVelocity	= 0.5;
	velocityVariance	= 0.4;
	ejectionOffset		= 0.3;
	thetaMin			= 0;
	thetaMax			= 180;
	phiReferenceVel		= 0;
	phiVariance			= 360;
	overrideAdvance		= false;
	particles			= "ThunderShotChargedParticle";
};

datablock ParticleData(ThunderShotSmokeParticle)
{
	dragCoefficient			= 3;
	gravityCoefficient		= -0.5;
	inheritedVelFactor		= 0.2;
	constantAcceleration	= 0.0;
	lifetimeMS				= 750;
	lifetimeVarianceMS		= 45;
	textureName				= "base/data/particles/cloud";
	spinSpeed				= 10.0;
	spinRandomMin			= -500.0;
	spinRandomMax			= 500.0;
	
	colors[0]				= "0.6 0.6 0.5 0.9";
	colors[1]				= "0.6 0.6 0.5 0.0";
	sizes[0]				= 0.25;
	sizes[1]				= 0.4;

	useInvAlpha				= false;
};
datablock ParticleEmitterData(ThunderShotSmokeEmitter)
{
	ejectionPeriodMS	= 4;
	periodVarianceMS	= 1;
	ejectionVelocity	= 0.7;
	velocityVariance	= 0.4;
	ejectionOffset		= 0.0;
	thetaMin			= 0;
	thetaMax			= 90;
	phiReferenceVel		= 0;
	phiVariance			= 360;
	overrideAdvance		= false;
	particles			= "ThunderShotSmokeParticle";
};

datablock ParticleData(ThunderShotTrailParticle)
{
	dragCoefficient			= 1;
	gravityCoefficient		= 0;
	inheritedVelFactor		= 0;
	constantAcceleration	= 0;
	lifetimeMS				= 500;
	lifetimeVarianceMS		= 0;
	textureName				= "base/data/particles/dot";
	
	colors[0]				= "0.9 0.8 0.0 1.0";
	colors[1]				= "0.9 0.8 0.0 0.5";
	sizes[0]				= 0.2;
	sizes[1]				= 0.2;

	useInvAlpha				= false;
};
datablock ParticleEmitterData(ThunderShotTrailEmitter)
{
	ejectionPeriodMS	= 1;
	periodVarianceMS	= 0;
	ejectionVelocity	= 0.0;
	velocityVariance	= 0.0;
	ejectionOffset		= 0.0;
	thetaMin			= 0;
	thetaMax			= 90;
	phiReferenceVel		= 0;
	phiVariance			= 360;
	overrideAdvance		= false;
	particles[0]		= "ThunderShotTrailParticle";
};

datablock ProjectileData(ThunderShotProjectile)
{
	directDamage		= 50;
	impactImpulse		= 600;
	verticalImpulse		= 200;
	explosion			= radiowaveExplosion;
	particleEmitter		= "ThunderShotTrailEmitter";
	
	muzzleVelocity		= 200;
	velInheritFactor	= 0;
	
	armingDelay			= 0;
	lifetime			= 100;
	fadeDelay			= 900;
	bounceElasticity	= 0;
	bounceFriction		= 0;
	isBallistic			= false;
	gravityMod			= 0.0;
	explodeOnDeath		= true;
	
	hasLight			= false;
	lightRadius			= 3.0;
	lightColor			= "0.7 0.7 0";
};

datablock ItemData(ThunderShotItem)
{
	category		= "Weapon";
	className		= "Weapon";

	shapeFile		= "./tesla.dts";
	rotate			= false;
	mass			= 1;
	density			= 0.2;
	elasticity		= 0.2;
	friction		= 0.6;
	emap			= true;

	uiName			= "Thundershot";
	iconName		= "./Icon_ThunderShot";
	doColorShift	= false;
	colorShiftColor	= "0.9 0.8 0.0 1.000";

	image			= ThunderShotImage;
	canDrop			= true;
};

datablock ShapeBaseImageData(ThunderShotImage)
{
	shapeFile			= "./tesla.dts";
	emap				= true;
	
	mountPoint			= 0;
	offset				= "0 0 0";
	eyeOffset			= 0;
	rotation			= eulerToMatrix( "0 0 0" );
	
	correctMuzzleVector	= true;
	
	className			= "WeaponImage";
	
	item				= ThunderShotItem;
	ammo				= " ";
	projectile			= ThunderShotProjectile;
	projectileType		= Projectile;
	
	melee				= false;
	armReady			= true;
	minShotTime			= 3000;
	
	doColorShift		= false;
	colorShiftColor		= ThunderShotItem.colorShiftColor;

	stateName[0]					= "Activate";
	stateTimeoutValue[0]			= 0.15;
	stateTransitionOnTimeout[0]		= "Spark";
	stateSound[0]			 		= weaponSwitchSound;

	stateName[1]					= "Spark";
	stateTimeoutValue[1]			= 0.2;
	stateTransitionOnTimeout[1]		= "Ready";
	stateEmitter[1]					= radioWaveExplosionEmitter;
	stateEmitterTime[1]				= 0.2;
	stateEmitterNode[1]				= "CoilPoint";
	stateSound[1]					= radioWaveExplosionSound;
	
	stateName[2]					= "Ready";
	stateTimeoutValue[2]			= 0.2;
	stateTransitionOnTimeout[2]		= "Ready";
	stateWaitForTimeout[2]			= false;
	stateEmitter[2]					= ThunderShotChargedEmitter;
	stateEmitterTime[2]				= 0.2;
	stateEmitterNode[2]				= "CoilPoint";
	stateTransitionOnTriggerDown[2]	= "Fire";
	stateAllowImageChange[2]		= true;

	stateName[3]					= "Fire";
	stateTransitionOnTimeout[3]		= "Reload";
	stateTimeoutValue[3]			= 0.14;
	stateFire[3]					= true;
	stateAllowImageChange[3]		= false;
	stateSequence[3]				= "Fire";
	stateScript[3]					= "onFire";
	stateEmitter[3]					= ThunderShotFlashEmitter;
	stateEmitterTime[3]				= 0.09;
	stateEmitterNode[3]				= "muzzleNode";
	stateWaitForTimeout[3]			= true;
	stateSound[3]					= ThunderShotFireSound;

	stateName[4]					= "Reload";
	stateEmitter[4]					= ThunderShotSmokeEmitter;
	stateEmitterTime[4]				= 2.9;
	stateEmitterNode[4]				= "muzzleNode";
	stateTimeoutValue[4]			= 3;
	stateTransitionOnTimeout[4]		= "Wait";
	
	stateName[5]					= "Wait";
	stateTransitionOnTriggerUp[5]	= "Spark";
};

function ThunderShotImage::onFire(%this,%obj,%slot)
{
	if((%obj.lastFireTime+%this.minShotTime) > getSimTime())
		return;
	%obj.lastFireTime = getSimTime();

	%obj.playThread(2, shiftAway);

	%projectile = %this.projectile;
	%spread = 0.003;
	%shellcount = 4;

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocityOrig = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocityOrig);

		%p = new projectile()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
			SplitTimes = getRandom(10, 12);
			originalVector = %velocityOrig;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}

function ThunderShotProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
	%obj.hasHit = 1;
	parent::onCollision(%this,%obj,%col,%fade,%pos,%normal);
}

function ThunderShotProjectile::onExplode(%this, %obj, %pos)
{
	if(%obj.splittimes <= 0 || %obj.hasHit)
		return;
	%spread = 0.004;
	%initvelocity = vectorscale(%obj.originalVector, ThunderShotProjectile.muzzlevelocity);
	if(getRandom(1,4) != 1)
	{
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, vectorscale(%obj.initialvelocity, ThunderShotProjectile.muzzlevelocity));
	}
	else
		%velocity = %initvelocity;
	%p = new projectile()
	{
		dataBlock = ThunderShotProjectile;
		initialVelocity = %velocity;
		initialPosition = %pos;
		sourceObject = %obj;
		sourceSlot = %obj.slot;
		client = %obj.client;
		SplitTimes = %obj.splittimes - 1;
		originalVector = %obj.originalVector;
	};
	missionCleanup.add(%p);
	if(getRandom(1,5) == 1)
	{
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %initvelocity);
		%p = new projectile()
		{
			dataBlock = ThunderShotProjectile;
			initialVelocity = %velocity;
			initialPosition = %pos;
			sourceObject = %obj;
			sourceSlot = %obj.slot;
			client = %obj.client;
			SplitTimes = %obj.splittimes / 1.5;
			originalVector = %obj.originalVector;
		};
		MissionCleanup.add(%p);
	}
}